VERSION 5.00
Begin VB.Form frmAPI_AI 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "API.AI demo by The trick"
   ClientHeight    =   2670
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4260
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2670
   ScaleWidth      =   4260
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboLang 
      Height          =   315
      ItemData        =   "frmAPI_AI.frx":0000
      Left            =   3000
      List            =   "frmAPI_AI.frx":000A
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox txtOut 
      Height          =   1995
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   540
      Width           =   3975
   End
   Begin VB.PictureBox picLevel 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   75
      Left            =   180
      ScaleHeight     =   0.176
      ScaleMode       =   0  'User
      ScaleWidth      =   22197.68
      TabIndex        =   1
      Top             =   240
      Width           =   2235
   End
   Begin VB.CommandButton cmdRec 
      Caption         =   "M"
      Height          =   315
      Left            =   2580
      TabIndex        =   0
      Top             =   120
      Width           =   375
   End
End
Attribute VB_Name = "frmAPI_AI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' // frmAPI_AI.frm - test form for speech recognition using API.AI
' //  Krivous Anatoly Anatolevich (The trick), 2016

Option Explicit

Dim WithEvents snd          As clsTrickSound2
Attribute snd.VB_VarHelpID = -1
Dim WithEvents AIClient     As clsAPI_AI

Dim buffer      As clsSoundBuffer

Private Sub AIClient_Answer( _
            ByVal text As String)
    txtOut = txtOut & text & vbNewLine
End Sub

Private Sub cboLang_Click()
    AIClient.Language = cboLang.List(cboLang.ListIndex)
End Sub

Private Sub cmdRec_Click()
    
    If snd.IsUnavailable Then
        
        snd.Uninitialize
        picLevel.cls
        RecognizeBuffer
        
        Exit Sub
        
    Else
        buffer.Clear
    End If
    
    If Not snd.InitCapture(1, 16000, 16, 1024) Then
        MsgBox "Error capturing"
    End If
    
    snd.StartProcess
    
End Sub

Private Sub Form_Load()
    
    Set snd = New clsTrickSound2
    Set AIClient = New clsAPI_AI
    Set buffer = New clsSoundBuffer
    
    AIClient.Version = "20150910"
    AIClient.AccessToken = "b79d637397a14690865f7b8cabc9ff89"
    
    cboLang.ListIndex = 0
    
End Sub

Private Sub RecognizeBuffer()
    Dim buf() As Byte
    
    If buffer.SizeOfBuffer = 0 Then Exit Sub
    
    ReDim buf(buffer.SizeOfBuffer - 1)
    
    buffer.Extract VarPtr(buf(0)), buffer.SizeOfBuffer
    
    AIClient.SpeechToText buf()
    
End Sub

Private Sub snd_NewData(ByVal DataPtr As Long, ByVal CountBytes As Long)
    Dim buf()   As Integer
    Dim index   As Long
    Dim level   As Long
    
    ReDim buf(CountBytes \ 2 - 1)
    snd.CopyData VarPtr(buf(0)), DataPtr, CountBytes
    
    For index = 0 To UBound(buf)
        level = level + Abs(CLng(buf(index)))
    Next
    
    level = level \ (UBound(buf) + 1)
    
    picLevel.cls
    picLevel.Line (0, 0)-(level, 1), vbRed, BF
    
    buffer.AddToBuffer DataPtr, CountBytes
    
End Sub

